;---TUPPERA.ASM  - An ASM implementation of TOUPPER
;                  Argument in BX register,no return result
;                  (x/RHO)  in CX register - easier to do in APL
;                  than ASM ...

_TEXT       SEGMENT              ; define code segment
            assume cs:_TEXT, ds:_TEXT, ss:_TEXT, es:_TEXT

            org     0h      ; APL starts at 0
start:     ;db 10 dup(90h)  ; need 10 NOPs to get offsets
                            ; (relative to CS) correct.
                            ; These would be dropped in APL
           ;jmp     short begin

; ... insert constants and data here - will be relative to CS

begin:
main        proc    far             ; APL needs far return
            push    dx
            push    ds
            push    si

            int     3               ; useful for debugging purposes!

            mov     ds,[bx]         ; load argument SEGMENT to DS
            mov     ax,ds:[6]       ; load rank and type to AX
            dec     al              ; decrease AL by 1
            jz      isokay          ; if not zero, AL not 1,hence not char

badone:     int     0               ; signal domain error

isokay:     xchg    al,ah           ; switch AL,AH (rank to AL)
            shl     ax,1            ; mult AX (ie, rank) by 2
            add     ax,8            ; add data start for rank 0 array
            mov     si,ax           ; and load to SI

upperloop:  ;start processing the APL data here
            mov     al,[si]         ; get next char into AL
            cmp     al,'a'          ; below 'a'?
            jb      skip            ; you bet
            cmp     al,'z'          ; above 'z'?
            ja      skip            ; yup
            sub     al,' '          ; convert to uppercase
            mov     [si],al         ; put converted one back

skip:       inc     si              ; get to next character
            loop    upperloop       ; back for more

            pop     si
            pop     ds
            pop     dx

            retf
main        endp
_TEXT       ends
            end     start
